; SMS program made by Dave to check a state format
; Note 16-bit values are byteswapped (e.g. AF actually gets FA) so it's more readable
; in Intel save states

.MEMORYMAP
SLOTSIZE $4000
DEFAULTSLOT 0
SLOT 0 $0000
SLOT 1 $4000
.ENDME

.ROMBANKMAP
BANKSTOTAL $10
BANKSIZE $4000
BANKS $10
.ENDRO

.emptyfill $00
.smstag

.bank 0 slot 0
.orga $0000


  di ; disable interrupts
  im 1
  ld sp,$dff0 ; init stack pointer

; Write into bank select
  ld a,$00
  ld ($fffd),a
  ld a,$04
  ld ($fffe),a
  ld a,$09
  ld ($ffff),a

; Write (Ram...Ram) into Ram
  ld a,'('
  ld ($c000),a
  ld a,'R'
  ld ($c001),a
  ld a,'a'
  ld ($c002),a
  ld a,'m'
  ld ($c003),a

  ld a,'R'
  ld ($dffc),a
  ld a,'a'
  ld ($dffd),a
  ld a,'m'
  ld ($dffe),a
  ld a,')'
  ld ($dfff),a

; Write VRam into VRam
  ld a,$00
  out ($bf),a
  ld a,$40
  out ($bf),a

  ld a,$56
  out ($be),a
  ld a,$52
  out ($be),a
  ld a,$61
  out ($be),a
  ld a,$6d
  out ($be),a

; Write CRam into CRam
  ld a,$00
  out ($bf),a
  ld a,$c0
  out ($bf),a

  ld a,$43
  out ($be),a
  ld a,$52
  out ($be),a
  ld a,$61
  out ($be),a
  ld a,$6d
  out ($be),a

; Write VdpReg into registers
  ld a,'V'
  out ($bf),a
  ld a,$80
  out ($bf),a

  ld a,'d'
  out ($bf),a
  ld a,$81
  out ($bf),a

  ld a,'p'
  out ($bf),a
  ld a,$82
  out ($bf),a

  ld a,'R'
  out ($bf),a
  ld a,$83
  out ($bf),a

  ld a,'e'
  out ($bf),a
  ld a,$84
  out ($bf),a

  ld a,'g'
  out ($bf),a
  ld a,$85
  out ($bf),a

  ld a,$ff
  out ($bf),a
  ld a,$86
  out ($bf),a

  ld a,'7'
  out ($bf),a
  ld a,$87
  out ($bf),a

  ld a,'8'
  out ($bf),a
  ld a,$88
  out ($bf),a

  ld a,'9'
  out ($bf),a
  ld a,$89
  out ($bf),a

  ld a,'A'
  out ($bf),a
  ld a,$8a
  out ($bf),a

  ld a,'B'
  out ($bf),a
  ld a,$8b
  out ($bf),a

  ld a,'C'
  out ($bf),a
  ld a,$8c
  out ($bf),a

  ld a,'D'
  out ($bf),a
  ld a,$8d
  out ($bf),a

  ld a,'E'
  out ($bf),a
  ld a,$8e
  out ($bf),a

  ld a,'F'
  out ($bf),a
  ld a,$8f
  out ($bf),a

; Write 'c'05 into cram address select
  ld a,'c'
  out ($bf),a
  ld a,$c5
  out ($bf),a

; Write 'v'05 into vram address select ( 'v' after increment)
  ld a,'u'
  out ($bf),a
  ld a,$45
  out ($bf),a

; Write a 'd' into Data port (be)
  ld a,'d'
  out ($be),a

; Leave 'l' in the low byte
  ld a,'l'
  out ($bf),a

  ld sp,$dff0 ; stack pointer
; Set prime af
  ld bc,$6661 ; af
  push bc
  pop af
  ex af,af'

; Set normal af
  ld bc,$4641 ; AF
  push bc
  pop af

; Tidy up Ram
  ld bc,$0000
  push bc
  pop bc

; Set prime registers
  ld bc,$6362 ; bc
  ld de,$6564 ; de
  ld hl,$6c68 ; hl
  ld sp,$7073 ; sp
  exx

; Set normal registers
  ld bc,$4342 ; BC
  ld de,$4544 ; DE
  ld hl,$4c48 ; HL
  ld ix,$5849 ; IX
  ld iy,$5949 ; IY
  ld sp,$5053 ; SP

  jp Start

.orga $2a50  ; P*
Start:
  jp Start

; ------------------------------------------------------
